<script lang="ts">
  import { CardType, getCardType } from "../utils";

  export let card: CardId | null = null;
  export let suit: CardType | null = null;

  export let inline: boolean = false;

  let cardType: CardType | null;
  $: if (suit !== null) {
    cardType = suit;
  } else if (card !== null) {
    cardType = getCardType(card);
  } else {
    cardType = null;
  }

  $: iconEmoji = cardType !== null ? getIconEmoji(cardType) : "";

  function getIconEmoji(cardType: CardType) {
    switch (cardType) {
      case CardType.Tempura:
        return "🍤";
      case CardType.Dango:
        return "🍡";
      case CardType.Gyoza:
        return "🥟";
      case CardType.RiceBall:
        return "🍙";
      case CardType.Sushi:
        return "🍣";
      case CardType.Dessert:
        return "🍧";
      case CardType.Tea:
        return "🍵";
      case CardType.TakeoutBox:
        return "🥡";

      default:
        return "";
    }
  }
</script>

<div class="wrapper" class:inline>
  <div class="emoji" class:wasabi={cardType === CardType.Tea}>
    {iconEmoji}
  </div>
</div>

<style>
  .wrapper {
    position: relative;
    height: 1.25em;
    width: 1.25em;
  }
  .wrapper.inline {
    display: inline;
    padding-right: 1.5em;
  }
  .emoji {
    display: inline-block;
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);

    filter: drop-shadow(0 0 1px #5555) drop-shadow(0 0 1px #5555);
  }
</style>
